<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source to the Rust file `/home/keir/.cargo/registry/src/github.com-1ecc6299db9ec823/rand-0.7.3/src/distributions/unit_sphere.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>unit_sphere.rs.html -- source</title><link rel="stylesheet" type="text/css" href="../../../normalize.css"><link rel="stylesheet" type="text/css" href="../../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../../dark.css"><link rel="stylesheet" type="text/css" href="../../../light.css" id="themeStyle"><script src="../../../storage.js"></script><noscript><link rel="stylesheet" href="../../../noscript.css"></noscript><link rel="shortcut icon" href="https://www.rust-lang.org/favicon.ico"><style type="text/css">#crate-search{background-image:url("../../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 8]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu">&#9776;</div><a href='../../../rand/index.html'><div class='logo-container'><img src='https://www.rust-lang.org/logos/rust-logo-128x128-blk.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!"><img src="../../../brush.svg" width="18" alt="Pick another theme!"></button><div id="theme-choices"></div></div><script src="../../../theme.js"></script><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><a id="settings-menu" href="../../../settings.html"><img src="../../../wheel.svg" width="18" alt="Change settings"></a></div></form></nav><section id="main" class="content"><pre class="line-numbers"><span id="1"> 1</span>
<span id="2"> 2</span>
<span id="3"> 3</span>
<span id="4"> 4</span>
<span id="5"> 5</span>
<span id="6"> 6</span>
<span id="7"> 7</span>
<span id="8"> 8</span>
<span id="9"> 9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
</pre><div class="example-wrap"><pre class="rust ">
<span class="comment">// Copyright 2018 Developers of the Rand project.</span>
<span class="comment">//</span>
<span class="comment">// Licensed under the Apache License, Version 2.0 &lt;LICENSE-APACHE or</span>
<span class="comment">// https://www.apache.org/licenses/LICENSE-2.0&gt; or the MIT license</span>
<span class="comment">// &lt;LICENSE-MIT or https://opensource.org/licenses/MIT&gt;, at your</span>
<span class="comment">// option. This file may not be copied, modified, or distributed</span>
<span class="comment">// except according to those terms.</span>

<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">deprecated</span>)]</span>
<span class="attribute">#![<span class="ident">allow</span>(<span class="ident">clippy</span>::<span class="ident">all</span>)]</span>

<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::{<span class="ident">Distribution</span>, <span class="ident">Uniform</span>};
<span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">Rng</span>;

<span class="doccomment">/// Samples uniformly from the surface of the unit sphere in three dimensions.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// Implemented via a method by Marsaglia[^1].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// [^1]: Marsaglia, George (1972). [*Choosing a Point from the Surface of a</span>
<span class="doccomment">///       Sphere.*](https://doi.org/10.1214/aoms/1177692644)</span>
<span class="doccomment">///       Ann. Math. Statist. 43, no. 2, 645--646.</span>
<span class="attribute">#[<span class="ident">deprecated</span>(<span class="ident">since</span> <span class="op">=</span> <span class="string">&quot;0.7.0&quot;</span>, <span class="ident">note</span> <span class="op">=</span> <span class="string">&quot;moved to rand_distr crate&quot;</span>)]</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">UnitSphereSurface</span>;

<span class="kw">impl</span> <span class="ident">UnitSphereSurface</span> {
    <span class="doccomment">/// Construct a new `UnitSphereSurface` distribution.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">UnitSphereSurface</span> {
        <span class="ident">UnitSphereSurface</span>
    }
}

<span class="kw">impl</span> <span class="ident">Distribution</span><span class="op">&lt;</span>[<span class="ident">f64</span>; <span class="number">3</span>]<span class="op">&gt;</span> <span class="kw">for</span> <span class="ident">UnitSphereSurface</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">sample</span><span class="op">&lt;</span><span class="ident">R</span>: <span class="ident">Rng</span> <span class="op">+</span> <span class="question-mark">?</span><span class="ident">Sized</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">rng</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">R</span>) <span class="op">-</span><span class="op">&gt;</span> [<span class="ident">f64</span>; <span class="number">3</span>] {
        <span class="kw">let</span> <span class="ident">uniform</span> <span class="op">=</span> <span class="ident">Uniform</span>::<span class="ident">new</span>(<span class="op">-</span><span class="number">1.</span>, <span class="number">1.</span>);
        <span class="kw">loop</span> {
            <span class="kw">let</span> (<span class="ident">x1</span>, <span class="ident">x2</span>) <span class="op">=</span> (<span class="ident">uniform</span>.<span class="ident">sample</span>(<span class="ident">rng</span>), <span class="ident">uniform</span>.<span class="ident">sample</span>(<span class="ident">rng</span>));
            <span class="kw">let</span> <span class="ident">sum</span> <span class="op">=</span> <span class="ident">x1</span> <span class="op">*</span> <span class="ident">x1</span> <span class="op">+</span> <span class="ident">x2</span> <span class="op">*</span> <span class="ident">x2</span>;
            <span class="kw">if</span> <span class="ident">sum</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">1.</span> {
                <span class="kw">continue</span>;
            }
            <span class="kw">let</span> <span class="ident">factor</span> <span class="op">=</span> <span class="number">2.</span> <span class="op">*</span> (<span class="number">1.0_f64</span> <span class="op">-</span> <span class="ident">sum</span>).<span class="ident">sqrt</span>();
            <span class="kw">return</span> [<span class="ident">x1</span> <span class="op">*</span> <span class="ident">factor</span>, <span class="ident">x2</span> <span class="op">*</span> <span class="ident">factor</span>, <span class="number">1.</span> <span class="op">-</span> <span class="number">2.</span> <span class="op">*</span> <span class="ident">sum</span>];
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">test</span>)]</span>
<span class="kw">mod</span> <span class="ident">tests</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="ident">UnitSphereSurface</span>;
    <span class="kw">use</span> <span class="kw">crate</span>::<span class="ident">distributions</span>::<span class="ident">Distribution</span>;

    <span class="doccomment">/// Assert that two numbers are almost equal to each other.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// On panic, this macro will print the values of the expressions with their</span>
    <span class="doccomment">/// debug representations.</span>
    <span class="macro">macro_rules</span><span class="macro">!</span> <span class="ident">assert_almost_eq</span> {
        (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>:<span class="ident">expr</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">prec</span>:<span class="ident">expr</span>) <span class="op">=</span><span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="ident">diff</span> <span class="op">=</span> (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span> <span class="op">-</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>).<span class="ident">abs</span>();
            <span class="kw">if</span> <span class="ident">diff</span> <span class="op">&gt;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">prec</span> {
                <span class="macro">panic</span><span class="macro">!</span>(<span class="macro">format</span><span class="macro">!</span>(
                    <span class="string">&quot;assertion failed: `abs(left - right) = {:.1e} &lt; {:e}`, \
                     (left: `{}`, right: `{}`)&quot;</span>,
                    <span class="ident">diff</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">prec</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">a</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">b</span>
                ));
            }
        };
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">norm</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">1</span>);
        <span class="kw">let</span> <span class="ident">dist</span> <span class="op">=</span> <span class="ident">UnitSphereSurface</span>::<span class="ident">new</span>();
        <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..<span class="number">1000</span> {
            <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> <span class="ident">dist</span>.<span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>);
            <span class="macro">assert_almost_eq</span><span class="macro">!</span>(<span class="ident">x</span>[<span class="number">0</span>] <span class="op">*</span> <span class="ident">x</span>[<span class="number">0</span>] <span class="op">+</span> <span class="ident">x</span>[<span class="number">1</span>] <span class="op">*</span> <span class="ident">x</span>[<span class="number">1</span>] <span class="op">+</span> <span class="ident">x</span>[<span class="number">2</span>] <span class="op">*</span> <span class="ident">x</span>[<span class="number">2</span>], <span class="number">1.</span>, <span class="number">1e-15</span>);
        }
    }

    <span class="attribute">#[<span class="ident">test</span>]</span>
    <span class="kw">fn</span> <span class="ident">value_stability</span>() {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">rng</span> <span class="op">=</span> <span class="kw">crate</span>::<span class="ident">test</span>::<span class="ident">rng</span>(<span class="number">2</span>);
        <span class="kw">let</span> <span class="ident">expected</span> <span class="op">=</span> [
            [<span class="number">0.03247542860231647</span>, <span class="op">-</span><span class="number">0.7830477442152738</span>, <span class="number">0.6211131755296027</span>],
            [<span class="op">-</span><span class="number">0.09978440840914075</span>, <span class="number">0.9706650829833128</span>, <span class="op">-</span><span class="number">0.21875184231323952</span>],
            [<span class="number">0.2735582468624679</span>, <span class="number">0.9435374242279655</span>, <span class="op">-</span><span class="number">0.1868234852870203</span>],
        ];
        <span class="kw">let</span> <span class="ident">samples</span> <span class="op">=</span> [
            <span class="ident">UnitSphereSurface</span>.<span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>),
            <span class="ident">UnitSphereSurface</span>.<span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>),
            <span class="ident">UnitSphereSurface</span>.<span class="ident">sample</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">rng</span>),
        ];
        <span class="macro">assert_eq</span><span class="macro">!</span>(<span class="ident">samples</span>, <span class="ident">expected</span>);
    }
}
</pre></div>
</section><section id="search" class="content hidden"></section><section class="footer"></section><script>window.rootPath = "../../../";window.currentCrate = "rand";</script><script src="../../../main.js"></script><script src="../../../source-script.js"></script><script src="../../../source-files.js"></script><script defer src="../../../search-index.js"></script></body></html>